package dev.fyloz.trial.colorrecipesexplorer.model

import java.util.*
import javax.persistence.*

const val IDENTIFIER_MIX_TYPE_NAME = "mixType"

@Entity
data class Mix(
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    override val id: Long?,

    var location: String?,

    @ManyToOne
    val recipe: Recipe,

    @ManyToOne
    val mixType: MixType,

    @OneToMany
    val mixMaterials: Collection<MixMaterial>,
) : Model {
    constructor(recipe: Recipe, mixType: MixType) : this(null, null, recipe, mixType, listOf())

    override fun equals(other: Any?): Boolean = other is Mix && recipe == other.recipe && mixType == other.mixType
    override fun hashCode(): Int = Objects.hash(recipe, mixType)
}

// ==== DSL ====
fun mix(
    id: Long? = null,
    location: String = "location",
    recipe: Recipe = recipe(),
    mixType: MixType = mixType(),
    mixMaterials: Collection<MixMaterial> = listOf(),
    op: Mix.() -> Unit = {}
) = Mix(id, location, recipe, mixType, mixMaterials).apply(op)
