package dev.fyloz.trial.colorrecipesexplorer.service

import dev.fyloz.trial.colorrecipesexplorer.model.Mix
import dev.fyloz.trial.colorrecipesexplorer.repository.MixRepository
import org.springframework.stereotype.Service

interface MixService : ModelService<Mix, MixRepository> {
    /** Updates the location of the given [mix] to the given [location]. */
    fun updateLocation(mix: Mix, location: String)
}

@Service
class MixServiceImpl(mixRepository: MixRepository) : AbstractModelService<Mix, MixRepository>(mixRepository),
    MixService {
    override fun updateLocation(mix: Mix, location: String) {
        update(mix.apply { this.location = location })
    }
}
