package dev.fyloz.trial.colorrecipesexplorer.service

import com.nhaarman.mockitokotlin2.*
import dev.fyloz.trial.colorrecipesexplorer.model.Mix
import dev.fyloz.trial.colorrecipesexplorer.model.mix
import dev.fyloz.trial.colorrecipesexplorer.repository.MixRepository
import org.junit.jupiter.api.Nested
import org.junit.jupiter.api.Test

class MixServiceTest : AbstractModelServiceTest<Mix, MixService, MixRepository>() {
    override val repository: MixRepository = mock()
    override val service: MixService = spy(MixServiceImpl(repository))

    override val entity: Mix = mix(id = 0L, location = "location")
    override val anotherEntity: Mix = mix(id = 1L)

    @Nested
    inner class UpdateLocation {
        @Test
        fun `calls update() with the given mix with the given location`() {
            val newLocation = "new location"
            val expected = entity.apply { location = newLocation }
            doReturn(expected).whenever(service).update(expected)

            service.updateLocation(entity, newLocation)

            verify(service).update(expected)
        }
    }
}
